(* Copyright (C) 2014, Daniel Wyckoff, except for the portions so labeleled
which I got from Daniel Schepler*)



(*		   GNU LESSER GENERAL PUBLIC LICENSE
                       Version 3, 29 June 2007

 Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.


  This version of the GNU Lesser General Public License incorporates
the terms and conditions of version 3 of the GNU General Public
License, supplemented by the additional permissions listed below.

  0. Additional Definitions. 

  As used herein, "this License" refers to version 3 of the GNU Lesser
General Public License, and the "GNU GPL" refers to version 3 of the GNU
General Public License.

  "The Library" refers to a covered work governed by this License,
other than an Application or a Combined Work as defined below.

  An "Application" is any work that makes use of an interface provided
by the Library, but which is not otherwise based on the Library.
Defining a subclass of a class defined by the Library is deemed a mode
of using an interface provided by the Library.

  A "Combined Work" is a work produced by combining or linking an
Application with the Library.  The particular version of the Library
with which the Combined Work was made is also called the "Linked
Version".

  The "Minimal Corresponding Source" for a Combined Work means the
Corresponding Source for the Combined Work, excluding any source code
for portions of the Combined Work that, considered in isolation, are
based on the Application, and not on the Linked Version.

  The "Corresponding Application Code" for a Combined Work means the
object code and/or source code for the Application, including any data
and utility programs needed for reproducing the Combined Work from the
Application, but excluding the System Libraries of the Combined Work.

  1. Exception to Section 3 of the GNU GPL.

  You may convey a covered work under sections 3 and 4 of this License
without being bound by section 3 of the GNU GPL.

  2. Conveying Modified Versions.

  If you modify a copy of the Library, and, in your modifications, a
facility refers to a function or data to be supplied by an Application
that uses the facility (other than as an argument passed when the
facility is invoked), then you may convey a copy of the modified
version:

   a) under this License, provided that you make a good faith effort to
   ensure that, in the event an Application does not supply the
   function or data, the facility still operates, and performs
   whatever part of its purpose remains meaningful, or

   b) under the GNU GPL, with none of the additional permissions of
   this License applicable to that copy.

  3. Object Code Incorporating Material from Library Header Files.

  The object code form of an Application may incorporate material from
a header file that is part of the Library.  You may convey such object
code under terms of your choice, provided that, if the incorporated
material is not limited to numerical parameters, data structure
layouts and accessors, or small macros, inline functions and templates
(ten or fewer lines in length), you do both of the following:

   a) Give prominent notice with each copy of the object code that the
   Library is used in it and that the Library and its use are
   covered by this License.

   b) Accompany the object code with a copy of the GNU GPL and this license
   document.

  4. Combined Works.

  You may convey a Combined Work under terms of your choice that,
taken together, effectively do not restrict modification of the
portions of the Library contained in the Combined Work and reverse
engineering for debugging such modifications, if you also do each of
the following:

   a) Give prominent notice with each copy of the Combined Work that
   the Library is used in it and that the Library and its use are
   covered by this License.

   b) Accompany the Combined Work with a copy of the GNU GPL and this license
   document.

   c) For a Combined Work that displays copyright notices during
   execution, include the copyright notice for the Library among
   these notices, as well as a reference directing the user to the
   copies of the GNU GPL and this license document.

   d) Do one of the following:

       0) Convey the Minimal Corresponding Source under the terms of this
       License, and the Corresponding Application Code in a form
       suitable for, and under terms that permit, the user to
       recombine or relink the Application with a modified version of
       the Linked Version to produce a modified Combined Work, in the
       manner specified by section 6 of the GNU GPL for conveying
       Corresponding Source.

       1) Use a suitable shared library mechanism for linking with the
       Library.  A suitable mechanism is one that (a) uses at run time
       a copy of the Library already present on the user's computer
       system, and (b) will operate properly with a modified version
       of the Library that is interface-compatible with the Linked
       Version. 

   e) Provide Installation Information, but only if you would otherwise
   be required to provide such information under section 6 of the
   GNU GPL, and only to the extent that such information is
   necessary to install and execute a modified version of the
   Combined Work produced by recombining or relinking the
   Application with a modified version of the Linked Version. (If
   you use option 4d0, the Installation Information must accompany
   the Minimal Corresponding Source and Corresponding Application
   Code. If you use option 4d1, you must provide the Installation
   Information in the manner specified by section 6 of the GNU GPL
   for conveying Corresponding Source.)

  5. Combined Libraries.

  You may place library facilities that are a work based on the
Library side by side in a single library together with other library
facilities that are not Applications and are not covered by this
License, and convey such a combined library under terms of your
choice, if you do both of the following:

   a) Accompany the combined library with a copy of the same work based
   on the Library, uncombined with any other library facilities,
   conveyed under the terms of this License.

   b) Give prominent notice with the combined library that part of it
   is a work based on the Library, and explaining where to find the
   accompanying uncombined form of the same work.

  6. Revised Versions of the GNU Lesser General Public License.

  The Free Software Foundation may publish revised and/or new versions
of the GNU Lesser General Public License from time to time. Such new
versions will be similar in spirit to the present version, but may
differ in detail to address new problems or concerns.

  Each version is given a distinguishing version number. If the
Library as you received it specifies that a certain numbered version
of the GNU Lesser General Public License "or any later version"
applies to it, you have the option of following the terms and
conditions either of that published version or of any later version
published by the Free Software Foundation. If the Library as you
received it does not specify a version number of the GNU Lesser
General Public License, you may choose any version of the GNU Lesser
General Public License ever published by the Free Software Foundation.

  If the Library as you received it specifies that a proxy can decide
whether future versions of the GNU Lesser General Public License shall
apply, that proxy's public statement of acceptance of any version is
permanent authorization for you to choose that version for the
Library.*)






(* Corresponds to the chapter "Infinite Operations" in Givant/Halmos'
   "Introduction to Boolean Algebras." *)
(*Add a function that takes an indexed element and some function on Bt
  And returns the sup/inf of the "composition" *)
(*Fix notation issue with -. and Bcompi*)
(* Insert indexed versions of lb and ub called Lb and Ub *)
(* Todo, explain duals to Coq *)
(*Add a basic theorem in Bool Alg, that le p*r p*)
(*Still have to fix the end of the module, so the signatures match, whatever that means.*)

Require Export BoolAlgBasics.
Require Import SetUtilities.
Require Export Image.
Require Import FunctionalExtensionality.
Require Export Basics.

Module Type INFNT. 
Parameter  B : Bool_Alg.
Declare Module BA:BAt with Definition B:=B. 
Include Bscs(BA).
Import BA.


Section infinite.
Variable It : Type.
Definition IS := Full_set It.

(*maybe delete soon*)
Record Ind_Set : Type := 
{(*IS : Ensemble It; *)
 non_empty : IS <> (Empty_set It)
}.

Variable I:Ind_Set.
(*Definition It := Itype I.*)

(*
Variable B : Bool_Alg.
Definition Bt := (Btype (Bc B)).
*)

Definition Bcompi (p: It->Bt) : It->Bt :=
  fun (i:It) => -(p i).

Notation "-. x" := (Bcompi x) (at level 30).


Lemma doub_neg_ind : forall (p : It->Bt), -.(-.p) = p.
intros p.
unfold Bcompi.
cut ((fun i : It => - - p i) = (fun i : It => p i)).
intro h.
apply h.
apply functional_extensionality.
intro x.
rewrite doub_neg. reflexivity.
Qed.

(*Lemma comp_sym_ind : forall*)

(*
Lemma inj_Bcompi : injective _ _ Bcompi.
unfold injective.
intros x y h.  unfold Bcompi in h.
*)


Definition SupGen (Gt:Type) (S:Ensemble Gt) (p:Gt->Bt) (b:Bt) : Prop := 
sup (Im S p) b.

Definition InfGen (Gt:Type) (S:Ensemble Gt) (p:Gt->Bt) (b:Bt) : Prop := 
inf (Im S p) b.

Definition Sup (p: It->Bt) (b:Bt) : Prop :=
SupGen It IS p b.

Definition Inf (p: It->Bt) (b:Bt) : Prop :=
InfGen It IS p b.

Lemma comp_ind : 
  forall (p : It->Bt) (x:Bt), Im IS p (-x) <-> Im IS (-.p) x.
intros p x.
split.
(* left *)
intro h.
inversion h.
assert (h1: --x = -(p x0)).
rewrite H0. reflexivity.
assert (h2: --x = x).
rewrite doub_neg. reflexivity.
assert (h3: x = (-.p) x0).
unfold Bcompi. congruence.
apply Im_intro with (x := x0).
apply H. apply h3.
(* right *)
intro h4.
inversion h4.
unfold Bcompi in H0.
assert (h5: -x = --p x0).
rewrite H0. reflexivity.
assert (h6: --p x0 = p x0).
rewrite doub_neg. reflexivity.
assert (h7: p x0 = -x). congruence.
apply Im_intro with (x := x0).
assumption. rewrite h7. reflexivity.
Qed.

Lemma infnt_de_mor1 : forall (p : It->Bt) (b:Bt), Sup p b -> Inf (-.p) (-b).
intros p b h1.
unfold Sup in h1. unfold SupGen in h1. unfold sup in h1. elim h1.
intros h1l h1r.
unfold ub in h1l.
unfold Inf. unfold inf. split. unfold lb.
(* -b is a lower bound for -.p *)
intros t h2.
cut (le (-t) b).
rewrite doub_neg with (x := t) at 2.
apply mono_comp.
unfold In in h2.
rewrite <- comp_ind in h2.
apply h1l with (s := -t).
unfold In. assumption.
(* next subgoal: -b is the greatest lower bound *)
intros b'.
unfold lb.
unfold In.
intro h3.
rewrite doub_neg with (x := b').
apply mono_comp.
apply h1r with (b' := -b').
unfold ub.
unfold In.
intros s.
intro h4.
rewrite doub_neg in h4.
rewrite comp_ind in h4.
assert (h5: le b' (-s)).
apply h3 with (s := -s).
assumption.
rewrite doub_neg with (x := s).
apply mono_comp.
assumption.
Qed.

(*Dual of the previous of course.*)
Lemma infnt_de_mor2 : forall (p : It->Bt) (b : Bt), Inf p b -> Sup (-.p) (-b).
intros p b h1.
unfold Inf in h1. unfold InfGen in h1. unfold inf in h1. elim h1.
intros h1l h1r.
unfold lb in h1l.
unfold Sup. unfold sup. split.  unfold ub.
(* -b is an upper bound for -.p*)
intros t h2.
cut (le b (-t)).
rewrite doub_neg with (x :=t) at 2.
apply mono_comp.
unfold In in h2.
rewrite <- comp_ind in h2.
apply h1l with (s := -t).
unfold In.  assumption.
(* next suboal: -b is the greatest lower bound *)
intros b'.
unfold ub.
unfold In.
intro h3.
rewrite doub_neg with (x := b').
apply mono_comp.
apply h1r with (b' := -b').
unfold lb.
unfold In.
intros s.
intro h4.
rewrite doub_neg in h4.
rewrite comp_ind in h4.
assert (h5: le (-s) b').
apply h3 with (s := -s).
assumption.
rewrite doub_neg with (x := s).
apply mono_comp.
assumption.
Qed.

Lemma infnt_de_mor3 : forall (p : It->Bt) (b : Bt), Sup (-.p) b -> Inf p (-b).
intros p b h1.
rewrite <- doub_neg_ind with (p := p).
apply infnt_de_mor1 with (p := (-.p)).
assumption.
Qed.

Lemma infnt_de_mor4 : forall (p : It->Bt) (b : Bt), Inf (-.p) b -> Sup p (-b).
intros p b h1.
rewrite <- doub_neg_ind with (p := p).
apply infnt_de_mor2 with (p := (-.p)).
assumption.
Qed.

Definition complete : Prop := forall (p : It->Bt), (exists b_, Inf p b_) /\ 
                                                   (exists b', Sup p b').

Lemma complete_sup : (forall (p : It->Bt), (exists b', Sup p b')) -> complete.
intros h1.
unfold complete.
intro p. split.
assert (h2: exists b':Bt, Sup (-.p) b').
apply h1 with (p := -.p).
elim h2.
intros q.
intro h3.
clear h2.
assert (h4: Inf p (-q)).
apply infnt_de_mor3. assumption.
exists (-q).  assumption.
apply h1.
Qed.

(*Dual*)
Lemma complete_inf : (forall (p : It->Bt), (exists b_, Inf p b_)) -> complete.
intros h1.
unfold complete.
intro p. split.
apply h1.
assert (h2: exists b_:Bt, Inf (-.p) b_).
apply h1 with (p := -.p).
elim h2.
intros q.  intro h3. clear h2.
assert (h4: Sup p (-q)).
apply infnt_de_mor4. assumption.
exists (-q). assumption.
Qed.


Section infnt_assoc.
Variable Jt:Type.

Record Ind_Ind_Set : Type := 
{(* IItype : Ensemble Itype';*)
 IIS: Ensemble (Ensemble It); 
 covers : (FamilyUnion IIS) = IS;
 non_empty_I : forall (S:(Ensemble It)), (In IIS S) -> S <> (Empty_set It);
 non_empty_II : exists S:(Ensemble It), In IIS S
(* und_set_II : Inhabited It IISU*)
 (*und_set_j : forall (j:Jt), *)
}.

Variable II : Ind_Ind_Set.

Lemma inhbtd_IIS : forall (i:It), In (FamilyUnion (IIS II)) i.
intros i.
assert (h1:In IS i).
  unfold IS. apply Full_intro with (U:=It) (x:=i).
assert (h9: (FamilyUnion (IIS II)) = IS).
  apply covers.
rewrite h9.
assumption.
Qed.

Lemma infnt_assoc_sup : 
    (forall  (p: It -> Bt) (q:Jt->Bt), 
    (forall (S:Ensemble It), In (IIS II) S ->       
     (exists (j:Jt), SupGen It S p (q j))) -> 
    (forall (j:Jt), exists (S:Ensemble It), In (IIS II) S 
                          /\ SupGen It S p (q j)) ->
     (forall (q':Bt), SupGen Jt (Full_set Jt) q q' ->
      Sup p q')).
intros p q h1 h2' q'. intro h4.  
assert (h7: ub (Im IS p) q').
  unfold ub.
  intros b h8.
  unfold In in h8. inversion h8.
  assert (h5:forall (i:It), (exists (S1:(Ensemble It)), (In (IIS II) S1) /\
    In S1 i)).  
    intro i.
    assert (h6: In (FamilyUnion (IIS II)) i).
    apply inhbtd_IIS.
    inversion h6.
    exists S.
    tauto.
  assert (h10:exists S1 : Ensemble It, In (IIS II) S1 /\ In S1 x).
  apply h5.
  elim h10.
  intros S1 h.
  assert (h11: exists j : Jt, SupGen It S1 p (q j)).
  apply h1. apply h.
  elim h11. intros j h12.
  assert (h13: le b (q j)).
    apply h12.
    unfold In. 
    apply Im_intro with (x := x) (y := b).
    apply h.
    unfold In.
    assumption.
  assert (h14: le (q j) q').
    apply h4.
    unfold In. apply Im_intro with (x := j).
    apply Full_intro.  reflexivity.
  apply trans_le with (x := b) (y := (q j)) (z := q').
  assumption.  assumption.
  assert (h15: forall r:Bt, ub (Im IS p) r -> le q' r).
    intros r h16.
    assert (h17: forall (S: Ensemble It), In (IIS II) S ->
                 exists j : Jt, le (q j) r).
      intros S h30.
      assert (h31: exists j : Jt, SupGen It S p (q j)).
        apply h1. apply h30.
        elim h31.
        intros j h32.
    assert (h21: le (q j) r).
      apply h32. unfold ub.
        intros b' h22. unfold In in h22. inversion h22.        
        apply h16.           
      unfold In.
      assert (h23: In IS x).
        unfold IS.
      apply Full_intro.
      apply Im_intro with (x := x).
      assumption. assumption.
    exists j. assumption.
    assert (h24: ub (Im (Full_set Jt) q) r).
      unfold ub.  
      intros b h25. unfold In in h25. inversion h25. 
      assert (h26: exists S : Ensemble It,
        In (IIS II) S /\ SupGen It S p (q x)).
      apply h2'.
      elim h26. intros S h27.  
      elim h27. intros h27l h27r.
      rewrite <- H0 in h27r.
      apply h27r.  unfold ub.  
      intros b' h28. unfold In in h28. apply h16.
      inversion h28. rewrite H3. unfold In. apply Im_intro with (x:=x0).
      assert (h29: (FamilyUnion (IIS II)) = IS).
        apply covers.
      unfold IS. apply Full_intro. reflexivity. 
    apply h4. apply h24.
unfold Sup. unfold SupGen. unfold sup. split.
apply h7. apply h15.
Qed.

(*dual*)
Lemma infnt_assoc_inf : 
    (forall  (p: It -> Bt) (q:Jt->Bt), 
    (forall (S:Ensemble It), In (IIS II) S ->       
     (exists (j:Jt), InfGen It S p (q j))) -> 
    (forall (j:Jt), exists (S:Ensemble It), In (IIS II) S 
                          /\ InfGen It S p (q j)) ->
     (forall (q':Bt), InfGen Jt (Full_set Jt) q q' ->
      Inf p q')).
intros p q h1 h2' q' h4.  
assert (h7: lb (Im IS p) q').
  unfold lb.
  intros b h8.
  unfold In in h8. inversion h8.
  assert (h5:forall (i:It), (exists (S1:(Ensemble It)), (In (IIS II) S1) /\
    In S1 i)).  
    intro i.
    assert (h6: In (FamilyUnion (IIS II)) i).
    apply inhbtd_IIS.
    inversion h6.
    exists S.
    tauto.
  assert (h10:exists S1 : Ensemble It, In (IIS II) S1 /\ In S1 x).
  apply h5.
  elim h10.
  intros S1 h.
  assert (h11: exists j : Jt, InfGen It S1 p (q j)).
  apply h1. apply h.
  elim h11. intros j h12.
  assert (h13: le (q j) b).
    apply h12.
    unfold In. 
    apply Im_intro with (x := x) (y := b).
    apply h.
    unfold In.
    assumption.
  assert (h14: le q' (q j)).
    apply h4.
    unfold In. apply Im_intro with (x := j).
    apply Full_intro.  reflexivity.
  apply trans_le with (x := q') (y := (q j)) (z := b).
  assumption.  assumption.
  assert (h15: forall r:Bt, lb (Im IS p) r -> le r q').
    intros r h16.
    assert (h17: forall (S: Ensemble It), In (IIS II) S ->
                 exists j : Jt, le r (q j)).
      intros S h30.
      assert (h31: exists j : Jt, InfGen It S p (q j)).
        apply h1. apply h30.
        elim h31.
        intros j h32.
    assert (h21: le r (q j)).
      apply h32. unfold lb.
        intros b' h22. unfold In in h22. inversion h22.        
        apply h16.           
      unfold In.
      assert (h23: In IS x).
        unfold IS.
      apply Full_intro.
      apply Im_intro with (x := x).
      assumption. assumption.
    exists j. assumption.
    assert (h24: lb (Im (Full_set Jt) q) r).
      unfold lb.  
      intros b h25. unfold In in h25. inversion h25. 
      assert (h26: exists S : Ensemble It,
        In (IIS II) S /\ InfGen It S p (q x)).
      apply h2'.
      elim h26. intros S h27.  
      elim h27. intros h27l h27r.
      rewrite <- H0 in h27r.
      apply h27r.  unfold lb.  
      intros b' h28. unfold In in h28. apply h16.
      inversion h28. rewrite H3. unfold In. apply Im_intro with (x:=x0).
      assert (h29: (FamilyUnion (IIS II)) = IS).
        apply covers.
      unfold IS. apply Full_intro. reflexivity. 
    apply h4. apply h24.
unfold Inf. unfold InfGen. unfold inf. split.
apply h7. apply h15.
Qed.
End infnt_assoc.


Lemma infnt_distr_1_sup : forall (p:Bt) (q:It->Bt) (q':Bt), 
  let pq := (compose (fun x:Bt => p*x) q) in  
  Sup q q' -> Sup pq (p*q').
intros p q q' pq h1.
assert (h2:ub (Im IS pq) (p*q')).
  unfold ub.
  intro s. unfold In. intro h3. inversion h3. 
  unfold pq in H0. unfold compose in H0.
  rewrite H0.
  apply mono_prod. apply refl_le.
  apply h1. unfold In. apply Im_intro with (x:=x). apply H.
    reflexivity.
assert (h4: forall r:Bt, ub (Im IS pq) r -> le (p*q') r).
 intros r h5.
 unfold ub in h5. 
 assert (h6: ub (Im IS q) (r + (-p))).
   unfold ub. intros b h7.
   unfold In in h7. inversion h7.
   assert (h8: b = (p + (-p)) * b). const_eq.
   assert (h9: (p + (-p))*b = (p*b) + (-p)*b).
     apply dist_sum_r.
   assert (h10: b = (p*b) + (-p)*b).
     congruence.
   assert (h11:le (p*b) r).
     apply h5.
     unfold In.
     rewrite H0.
     apply Im_intro with (x := x).
     apply H.
     unfold pq.
     unfold compose. reflexivity.
   assert (h12:le (-p*b) (-p)).
     unfold le. apply eq_ord. 
     assert (h13: (-p)*b*(-p) = (-p)*(-p)*b).  comm_eq.
     assert (h14: (-p)*(-p) = (-p)).
       apply idem_prod.
     rewrite h14 in h13.
     apply h13.
   assert (h15 : le (p*b + (-p*b)) (r + -p)).
     apply mono_sum.
   assumption.  assumption.
   rewrite  h10. assumption.
assert (h11: le q' (r+ (-p))).
  apply h1. assumption.
assert (h12: le p p).
  apply refl_le.
assert (h13: le (p*q') (p*(r+-p))).
  apply mono_prod. assumption. assumption.
assert (h14: p*(r+ -p) = p*r + p*-p).
  apply dist_sum.
assert (h15: p*r + p*-p = p*r).  const_eq.
assert (h16: le (p*r) r). unfold le.  apply eq_ord.
    assert (h18: r*r = r).  apply idem_prod.
    assert (h19: p*r*r = p*(r*r)). assoc_eq.
    rewrite h18 in h19. assumption.
rewrite <- h15 in h16.
rewrite <- h14 in h16.
apply trans_le with (x := (p*q')) (y := (p*(r+-p))) (z:=r).
assumption. assumption.
unfold Sup. unfold SupGen. unfold sup. split.
assumption. assumption.
Qed.

Lemma infnt_distr_1_inf : forall (p:Bt) (q:It->Bt) (q':Bt), 
  let pq := (compose (fun x:Bt => p+x) q) in  
  Inf q q' -> Inf pq (p+q').
intros p q q' pq h1.
assert (h2:lb (Im IS pq) (p+q')).
  unfold lb.
  intro s. unfold In. intro h3. inversion h3. 
  unfold pq in H0. unfold compose in H0.
  rewrite H0.
  apply mono_sum. apply refl_le.
  apply h1. unfold In. apply Im_intro with (x:=x). apply H.
    reflexivity.
assert (h4: forall r:Bt, lb (Im IS pq) r -> le r (p+q')).
 intros r h5.
 unfold lb in h5. 
 assert (h6: lb (Im IS q) (r * (-p))).
   unfold ub. intros b h7.
   unfold In in h7. inversion h7.
   assert (h8: b = (p * (-p)) + b). const_eq.
   assert (h9: (p * (-p))+b = (p+b) * ((-p)+b)).
     apply dist_prod_r.
   assert (h10: b = (p+b) * ((-p)+b)).
     congruence.
   assert (h11:le r (p+b)).
     apply h5.
     unfold In.
     rewrite H0.
     apply Im_intro with (x := x).
     apply H.
     unfold pq.
     unfold compose. reflexivity.
   assert (h12:le (-p) (-p+b)).
     unfold le.  
     assert (h13: (-p)+((-p)+b) = ((-p)+(-p))+b).  comm_eq.
     assert (h14: (-p)+(-p) = (-p)).      
       apply idem_sum.
     rewrite h14 in h13.
     apply h13.
   assert (h15 : le (r * -p) ((p+b) * (-p+b))).
     apply mono_prod.
   assumption.  assumption.
   rewrite  h10. assumption.
assert (h11: le (r * (-p)) q').
  apply h1. assumption.
assert (h12: le p p).
  apply refl_le.
assert (h13: le (p+(r*-p)) (p+q')).
  apply mono_sum. assumption. assumption.
assert (h14: p+(r * -p) = (p+r) *( p+-p)).
  apply dist_prod.
assert (h15: (p+r) * (p+-p) = p+r).  const_eq.
assert (h16: le r (p+r)). unfold le.  
    assert (h18: r+r = r).  apply idem_sum.
    assert (h19: r + (p + r) = (r + r) + p). comm_eq.
    rewrite h19. rewrite h18. comm_eq.
rewrite <- h15 in h16.
rewrite <- h14 in h16.
apply trans_le with (x := r) (y := (p+(r*-p))) (z:=p+q').
assumption. assumption.
unfold Inf. unfold InfGen. unfold inf. split.
assumption. assumption.
Qed.

End infinite.
End INFNT.
